//
//  ViewController.swift
//  SwiftPackageDemo
//
//  Created by Gabriel Theodoropoulos.
//  Copyright © 2019 AppCoda. All rights reserved.
//

import UIKit

class ViewController: UIViewController {

    // MARK: - IBOutlet Properties
    
    @IBOutlet weak var textField: UITextField!
    
    
    // MARK: - Properties
    
    var shouldClearText = false
    
    var didTypeValue = false
    
    
    // MARK: - VC Life Cycle
    
    override func viewDidLoad() {
        super.viewDidLoad()
        // Do any additional setup after loading the view.
        
        textField.delegate = self
    }


    // MARK: - IBAction Methods
        
    @IBAction func performOperation(_ sender: Any) {
        guard let button = sender as? UIButton else { return }
        
        showResult(self)
        
        switch button.tag {
        case 1: MathOperations.shared.operation = .addition
        case 2: MathOperations.shared.operation = .subtraction
        case 3: MathOperations.shared.operation = .multiplication
        case 4: MathOperations.shared.operation = .division
        default: break
        }

    }
    
    
    @IBAction func showResult(_ sender: Any) {
        if didTypeValue, let text = textField.text, text != "", let value = Double(text) {
            MathOperations.shared.keep(value)
            MathOperations.shared.calculateResult()
            shouldClearText = true
            didTypeValue = false
        }
        
        if let result = MathOperations.shared.getFormattedResult() {
            textField.text = result
        }
    }


    @IBAction func clear(_ sender: Any) {
        textField.text = ""
        MathOperations.shared.clear()
    }
}



extension ViewController: UITextFieldDelegate {
    func textField(_ textField: UITextField, shouldChangeCharactersIn range: NSRange, replacementString string: String) -> Bool {
        if shouldClearText {
            textField.text = ""
            shouldClearText = false
        }
        
        didTypeValue = true
        
        return true
    }
    
}
